import math
import random


class QuestionCategory:
	def __init__(self, topic: str, topic_size: int = 1):
		self.question_list = []
		self.topic = topic
		self.topic_size = topic_size
		self.ksat_set = set()

	# sort the questions by the weight in descending order
	def weight_sort(self):
		self.question_list.sort(key=lambda x: x.weight, reverse=True)

	# attempt to add KSATs to a set, returning the amount of KSATs that were added successfully
	def add_ksats(self, new_ksats):
		insert_count = 0
		for i in new_ksats:
			if i not in self.ksat_set:
				self.ksat_set.add(i)
				insert_count += 1
		return insert_count

	def apply_ksat_weights(self):
		self.ksat_set = set()
		self.weight_sort()
		for i in self.question_list:
			ksat_weight = self.add_ksats(i.ksat_list)
			# slow the rate of growth of bonus weight via ksat
			ksat_w_mod = math.log2(ksat_weight + 1)  # add 1 to prevent log(1) = 0
			i.weight *= ksat_w_mod

	def create_question_set(self, set_size: int, time_allowed: int, time_used: int):
		ex_list = []
		self.apply_ksat_weights()
		self.weight_sort()
		index = 0
		if len(self.question_list) < set_size:
			msg = f"not enough '{self.topic}' questions to fulfill '{set_size}'"
			raise IndexError(msg)
		while len(ex_list) < set_size and index < len(self.question_list):
			if time_used + self.question_list[index].complete_time <= time_allowed:
				ex_list.append(self.question_list[index])
				time_used += self.question_list[index].complete_time
			index += 1
		return ex_list, time_used

	def create_rand_quest_set(self, set_size: int, time_allowed: int, time_used: int):
		ex_list = []
		tried = []
		if len(self.question_list) < set_size:
			raise IndexError(f"not enough '{self.topic}' questions to fulfill '{set_size}'")
		while len(ex_list) < set_size and len(tried) < len(self.question_list):
			num = random.randint(0, len(self.question_list) - 1)
			if self.question_list[num] not in ex_list and (
					time_used + self.question_list[num].complete_time <= time_allowed):
				ex_list.append(self.question_list[num])
				time_used += self.question_list[num].complete_time
			if self.question_list[num] not in tried:
				tried.append(self.question_list[num])
		return ex_list, time_used

	def update_question_set(self, exam_q_list, no_tests):
		"""
		Purpose: Adjust the question's times_provisioned and weight for each one selected.
		:param exam_q_list: The questions selected for an exam
		:param no_tests: The total number of questions generated by the exam generator
		:return: None
		"""
		for ex in exam_q_list:
			for q in self.question_list:
				if ex.question_id == q.question_id:
					q.times_provisioned += 1
					# update times asked
					# update correct answers

		for q in self.question_list:
			q.get_question_weight(no_tests)
